#include <GServProblemC.h>
#include <math.h>
#include <stdio.h>


// a1-a2,b1-b2,c1-c2 	function region
double a1,a2,b1,b2,c1,c2;

// step for each dimension
static double step;

// cubesize - number of steps in the cube
int    cubesize;

// n1,n2,n3 - number of steps by dimension
int n1,n2,n3;


// portionSize - number of function calls in the portion
// maxPortionNumber - the last portion
int portionSize;
int maxPortionNumber = 0;


void initialize(char *arg) {

  // Parse arguments of the task
  // a1-a2,b1-b2,c1-c2 	function region
  // step 		step for each dimension
  // cubesize		number of steps in the cube
  //
  if (sscanf(arg,"%lf %lf %lf %lf %lf %lf %lf %d",&
	a1,&a2,&b1,&b2,&c1,&c2,&step,&cubesize) != 8) {
    fprintf(stderr, "3deq error: incorrect arguments!\n");
    exit(-1);
  }

  // Calculate number of steps by dimension
  //
  n1 = ((int)((a2-a1)/step+1e-6) + cubesize - 1)/cubesize;
  n2 = ((int)((b2-b1)/step+1e-6) + cubesize - 1)/cubesize;
  n3 = ((int)((c2-c1)/step+1e-6) + cubesize - 1)/cubesize;

  // Total number of portions and weight of the portion
  //
  maxPortionNumber = n1*n2*n3;
  portionSize = cubesize*cubesize*cubesize;

  // Write info to the stdout
  // 
  printf("3deq> portion size (number of function calls): %d\n",portionSize);
  printf("3deq> number of portions: %d\n",maxPortionNumber);

  // Delete file with the result data
  //
  unlink("../tasks/3deq/result.dat");
}

long getFirstPortionNumber() {
  return 1;
}

long getLastPortionNumber() {
  return maxPortionNumber;
}

int isFinished() {
  return 0;  
}

char *getPortion(long n) {
char tmp[1024];

  // pass each time all the parameters and the portion number
  //
  sprintf(tmp,"%lf %lf %lf %lf %lf %lf %lf %d %d %d %d %ld\n",
	a1,a2,b1,b2,c1,c2,step,cubesize,n1,n2,n3,n);

  return tmp;
}

double getPortionSizeGigaflop(long n) {
  
  // Idea is try to predict the difficulty of the protion
  // No need to do it carefully
  //
  return portionSize/1000000.0;
}

void addPortion(long n,char *data) {
FILE *f;

  if (!(f = fopen("../tasks/3deq/result.dat","a"))) {
    fprintf(stderr, "3deq error: couln't open result file!\n");
    exit(-1);
  }

  fprintf(f,data);

  fclose(f);
}
