#include <GServProblemC.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

// Global TEST parameters
long pOutSizeMin,pOutSizeMax; // min & max outgoing (srv->clnt) portion sizes, bytes 
char pOutStrategy;	      // distribution strategy for outgoing portion sizes (C,R,I,D)
long pInSizeMin,pInSizeMax;   // min & max incoming (clnt->srv) portion sizes, bytes
char pInStrategy;	      // distribution strategy for incoming portion sizes (C,R,I,D)
long cTimeMin,cTimeMax;       // computation time for client, seconds
char cTimeStrategy;           // distribution strategy for client times (C,R,I,D,E)
long mSize;		      // matrix size for 'matrix', 'matrix_light' or 'matrix_ultralight', if needed
char mProg;		      // (N,M,L,U)
long pCount;                  // total number of portions

char s[]="1234567890";
// long *pSizes;

void initialize(char *arg) 
{
  long i=0;
  if (sscanf(arg,"%ld %ld %c %ld %ld %c %ld %ld %c %ld %c %ld",&pOutSizeMin,&pOutSizeMax,&pOutStrategy,&pInSizeMin,&pInSizeMax,&pInStrategy,&cTimeMin,&cTimeMax,&cTimeStrategy,&mSize,&mProg,&pCount)!=12) 
  {
    fprintf(stderr, "test error: incorrect arguments!\n");
    exit(-1);
  }
//  fprintf(stderr, "%s",portion); 
  if (pOutStrategy=='R')
    srandom(time(NULL)*(int)getpid());
  fprintf(stderr,"\npOutSizeMin\t = %ld\npOutSizeMax\t = %ld\npOutStrategy\t = %c\npInSizeMin\t = %ld\npInSizeMax\t = %ld\npInStrategy\t = %c\ncTimeMin\t = %ld\ncTimeMax\t = %ld\ncTimeStrategy\t = %c\nmSize\t\t = %ld\nmProg\t\t = %c\npCount\t\t = %ld\n",pOutSizeMin,pOutSizeMax,pOutStrategy,pInSizeMin,pInSizeMax,pInStrategy,cTimeMin,cTimeMax,cTimeStrategy,mSize,mProg,pCount);
  unlink("../tasks/test/portions.in");
  unlink("../tasks/test/portions.out");

}

long getFirstPortionNumber() 
{
  return 1;
}

long getLastPortionNumber() 
{
  return pCount;
}

int isFinished() 
{
  return 0;  
}

char *getPortion(long n) 
{
  char *portion;
  long pLength,i;
  FILE *f;
  if (pOutStrategy=='R') // R for Random
    pLength=pOutSizeMin+(random()%(pOutSizeMax-pOutSizeMin+1));
  else if (pOutStrategy=='I') // I for Increase
    pLength=pOutSizeMin+(int)((pOutSizeMax-pOutSizeMin)*n/pCount);
  else if (pOutStrategy=='D') // D for Decrease
    pLength=pOutSizeMax-(int)((pOutSizeMax-pOutSizeMin)*n/pCount);
  else // C for Constant
    pLength=pOutSizeMin;
  portion=malloc((pLength+1)*sizeof(char));
  if(portion==NULL)
  {
	  fprintf(stderr, "test error: malloc failed!\n");
	  exit(-2);
  }
  for (i=0; i<pLength; i++)
    portion[i]=s[i%10];
  portion[pLength]='\0';
  if (!(f=fopen("../tasks/test/portions.out","a")))
  {
    fprintf(stderr, "test error: can't open result.out!\n");
    exit(-1);
  }
  fprintf(f,"%ld\t%ld\n",n,pLength);
  fclose(f);
  return portion;
}

double getPortionSizeGigaflop(long n) 
{
  // Idea is try to predict the difficulty of the protion
  // No need to do it carefully
  //
  return 1/1000000.0;
}

void addPortion(long n,char *data) 
{
  FILE *f, *fr;
  long l;
  char fn[256];

  time_t     timer;
  struct tm  *tblock;
  timer = time(NULL);
  tblock = localtime(&timer);

//  char s_good[]="GOOD", s_bad[]="BAD", fn[128];
//  int width=log10(pCount)+1;
//  sprintf(fn,"../tasks/test/in/in.%0*ld",width,n);

  sprintf(fn,"%s%d-%02d-%02d-%02d","../tasks/test/in/result.dat.",tblock->tm_year+1900,tblock->tm_mon+1,tblock->tm_mday,tblock->tm_hour);

  if (!(f=fopen(fn,"a")))
  {
    fprintf(stderr, "test error: can't open %s!\n",fn);
    exit(-1);
  }
  fprintf(f,"%s\n",data);
  fclose(f);
  
  if (!(fr=fopen("../tasks/test/portions.in","a")))
  {
    fprintf(stderr, "test error: can't open result.out!\n");
    exit(-1);
  }
  l=strlen(data);
/*  
  if (l==portionSizeIn)
    fprintf(fr,"%ld:\t%ld\tOK\n",n,l);
  else
    fprintf(fr,"%ld:\t%ld\tBAD!\n",n,l);
*/
  fprintf (fr,"%ld\t%ld\n",n,l);
  fclose(fr);

}
/*
main()
{
  int i;
  initialize("1 20 > 2 200 > 3 300 > 20");
  for (i=1; i<=20; i++)
    fprintf (stderr,"%s\n",getPortion(i));
}
*/